include ../../meta/datatables

.container-fluid.p-0
    .row#sqHeader.col-grp-header
        .col
            h4.mt-2 Multiple Choices
                span.float-right +
            hr.mt-0.mb-1
    .row.mt-2.collapse.col-grp-1.col-grp-2
        .col
            .h4.mt-2 Configurations
            span.text-muted Randomize the choices so every student gets different order of answers. 
            br
            if(mcqOpts.randomanswers)
                input.chckbox#cbrandomanswers(type='checkbox' name='randomanswers' checked)
            else
                input.chckbox#cbrandomanswers(type='checkbox' name='randomanswers')
            label.chckboxlbl(for='randomanswers') Randomize Answers
            br
            br
            span.text-muted Only 1 correct answer for this question. Uncheck for multiple correct answers.
            br
            if(mcqOpts.style)
                input.chckbox#cbstyle(type='checkbox' name='style' checked)
            else
                input.chckbox#cbstyle(type='checkbox' name='style')
            label.chckboxlbl(for='style') Single Correct Answer
            br
            .h4.mt-2 Manage Answers
            if clone==true 
                p(style="font-weight: bold;").bold NOTE: You can only add, update or delete the choices after you have cloned the question.
            table#mcqTable.table.w-100
            
            div#mcqTableReq.invalid-feedback You need at least 1 choice in this section to update this question
            div#mcqTableReq2.invalid-feedback Single/Multiple-Correct Answer(s) Error!
            script.
                let mcqTable;
                $(document).ready(() => {
                    let mcqurl;
                    var clone = #{clone};
                    if(clone==true)
                        mcqurl = '/questions/info/#{bankid}/data/clonemcq/#{qnid}';
                    else
                        mcqurl = '/questions/info/#{bankid}/data/mcq/#{qnid}';
                    let mcqtc = $('#mcqTable');
                    if(clone!=true){
                    mcqTable = mcqtc.DataTable({
                        ajax: mcqurl,
                        dom: 'Brtilp',
                        responsive: true,
                        altEditor: true,
                        autoWidth: false,
                        deferRender: true,
                        select: 'single',
                        pageLength: 5,
                        lengthMenu: [5, 10, 20, 50, 100],
                        buttons: [
                            {text: 'Add', name: 'add'},
                            {extend: 'selected', text: 'Edit', name: 'edit'},
                            {extend: 'selected', text: 'Delete', name: 'delete'},
                            {text: 'Clear All', className: 'btn-danger', action: () => {
                                if (confirm("Are you sure you want to clear all choices? THIS ACTION CANNOT BE REVERSED"))
                                    $.ajax({url: mcqurl, type: 'DELETE', data: {type: "all"}, success: () => mcqtc.DataTable().ajax.reload()});
                                }
                            }
                        ],
                        columns: [
                            {title: 'ID', data: 'id', readonly: true, visible: false, type: 'hidden'},
                            {title: "Answer", data: "answer", type: 'text', className: 'newlinesupport'},
                            {title: "Correct", data: "iscorrect", type: 'checkbox', className: 'coliscorrect'},
                            {title: "Rationale", data: "rationale", type: 'text'},
                            {title: "Score", data: "score", type: 'number', step: 'any'},
                        ],
                        onAddRow: function (datatable, rowdata, success, error) {
                            $.ajax({url: mcqurl, type: 'PUT', data: rowdata, success: success, error: error});
                        },
                        onDeleteRow: function (datatable, rowdata, success, error) {
                            $.ajax({url: mcqurl, type: 'DELETE', data: rowdata, success: success, error: error});
                        },
                        onEditRow: function (datatable, rowdata, success, error) {
                            $.ajax({url: mcqurl, type: 'POST', data: rowdata, success: success, error: error});
                        }
                    });    
                    }else{ // No Add, Edit, Remove buttons when cloning. 
                    mcqTable = mcqtc.DataTable({
                        ajax: mcqurl,
                        dom: 'Brtilp',
                        responsive: true,
                        altEditor: true,
                        autoWidth: false,
                        deferRender: true,
                        select: 'single',
                        pageLength: 5,
                        lengthMenu: [5, 10, 20, 50, 100],
                        columns: [
                            {title: 'ID', data: 'id', readonly: true, visible: false, type: 'hidden'},
                            {title: "Answer", data: "answer", type: 'text', className: 'newlinesupport'},
                            {title: "Correct", data: "iscorrect", type: 'checkbox', className: 'coliscorrect'},
                            {title: "Rationale", data: "rationale", type: 'text'},
                            {title: "Score", data: "score", type: 'number', step: 'any'},
                        ]
                        
                    });
                    }
                    
                });

script.
    $(document).on("alteditor:delete_dialog_opened", () => {
        let modal_selector = $('#mcqTable')[0].altEditor.modal_selector;
        let ic = $(modal_selector).find("#Answer").closest('div');
        $("<span>Are you sure you wish to remove this choice? This cannot be reversed!</span><br /><br />").insertBefore(ic);
    });
script.
    $('#sqHeader').click(() => {$(".col-grp-1").collapse('hide'); $(".col-grp-2").collapse('show');$('.collapse-btn-adv').show();updateExp('#sqHeader',true);});
    $('#ansHeader').click(() => {$(".col-grp-1").collapse('hide');$(".col-grp-3").collapse('show');$('.collapse-btn-adv').show();updateExp('#ansHeader',true);});
script.
    function innerFormValidation(result) {
        let rowCnt = mcqTable.data().count();
        let choiceNotFound = !rowCnt || rowCnt < 0;
        let correctAnsCount = 0;
            var iscorrect = document.getElementsByClassName("coliscorrect");
            for (var i = 1; i < iscorrect.length; i++) {
                if(iscorrect[i].innerText == "true")
                    correctAnsCount++;
            }
        var correctFormat = false;
        if($('#cbstyle').is(':checked')){
            if(correctAnsCount == 1)
                correctFormat = true;
            else
                $("#mcqTableReq2").html("Single-Correct Answer is set, but you have "+ correctAnsCount +" correct answers.");
        }else{
            if(correctAnsCount > 1)
                correctFormat = true;
            else
                $("#mcqTableReq2").html("Multiple-Correct Answers is set, but you only have "+ correctAnsCount +" correct answer.");
        }
        if (choiceNotFound || correctAnsCount < 1 || correctFormat == false) {
            if(correctFormat==false){
                $("#mcqTableReq2").show();
            }else{
                $("#mcqTableReq").show();
            }
            $("#mcqTableColor").addClass("text-danger");
            return false;
        } else {
            $("#mcqTableReq").hide();
            $("#mcqTableReq2").hide();
            $("#mcqTableColor").removeClass("text-danger");
        }
        return result;
    }
script.
    $(document).ready(function() { 
        $('button:contains("Add"),button:contains("Edit")').click(function(e){
            loadTinymce();
        });
        //on Datatable update, remove tinymce so it can be reinitialize in next modal open
        $('#mcqTable').on('draw.dt', function() {
            tinymce.remove("#answer");
            tinymce.remove("#rationale");
        });
        // to detect 'close' button click when modal opens
        var intervalId = window.setInterval(function(){
            $('button:contains("Close")').click(function(e){
                tinymce.remove("#answer");
                tinymce.remove("#rationale");
            });
        }, 1000);

        
        function loadTinymce() {
            tinymce.init({
                selector: '.answer',
                height: 150,
                menubar: false,
                external_plugins: {'tiny_mce_wiris' : '/mathtype-tinymce5/plugin.min.js'},
                plugins: 'code codesample autosave emoticons lists link table visualchars wordcount paste',
                toolbar: 'cut copy paste | undo redo | forecolor backcolor styleselect bold italic visualchars | alignleft aligncenter alignright | bullist numlist outdent indent | table | ' +
                        'link emoticons | restoredraft code wordcount codesample tiny_mce_wiris_formulaEditor',
                table_toolbar: 'tabledelete | tableprops tablerowprops tablecellprops | tableinsertrowbefore tableinsertrowafter tabledeleterow | tableinsertcolbefore tableinsertcolafter tabledeletecol',
                contextmenu: 'link list spellchecker table',
                browser_spellcheck: true,
                setup: editor => {
                    // Apply the focus effect
                    editor.on("init", () => {editor.getContainer().style.transition = "border-color 0.15s ease-in-out, box-shadow 0.15s ease-in-out";});
                    editor.on("focus", () => {editor.getContainer().style.boxShadow = "0 0 0 .2rem rgba(0, 123, 255, .25)"; editor.getContainer().style.borderColor = "#80bdff";});
                    editor.on("blur", () => {editor.getContainer().style.boxShadow = ""; editor.getContainer().style.borderColor = "";});
                    editor.on("change", editor.save);
                }
            });

            tinymce.init({
                selector: '.rationale',
                height: 150,
                menubar: false,
                external_plugins: {'tiny_mce_wiris' : '/mathtype-tinymce5/plugin.min.js'},
                plugins: 'code codesample autosave emoticons lists link table visualchars wordcount paste',
                toolbar: 'cut copy paste | undo redo | forecolor backcolor styleselect bold italic visualchars | alignleft aligncenter alignright | bullist numlist outdent indent | table | ' +
                        'link emoticons | restoredraft code wordcount codesample tiny_mce_wiris_formulaEditor',
                table_toolbar: 'tabledelete | tableprops tablerowprops tablecellprops | tableinsertrowbefore tableinsertrowafter tabledeleterow | tableinsertcolbefore tableinsertcolafter tabledeletecol',
                contextmenu: 'link list spellchecker table',
                browser_spellcheck: true,
                setup: editor => {
                    // Apply the focus effect
                    editor.on("init", () => {editor.getContainer().style.transition = "border-color 0.15s ease-in-out, box-shadow 0.15s ease-in-out";});
                    editor.on("focus", () => {editor.getContainer().style.boxShadow = "0 0 0 .2rem rgba(0, 123, 255, .25)"; editor.getContainer().style.borderColor = "#80bdff";});
                    editor.on("blur", () => {editor.getContainer().style.boxShadow = ""; editor.getContainer().style.borderColor = "";});
                    editor.on("change", editor.save);
                }
            });
        }
    });